import static java.math.BigInteger.valueOf;
import static java.util.Arrays.deepToString;
import static java.util.Arrays.sort;

import java.io.*;
import java.util.*;

public class lcm_nn_evenfaster {
	static final int MOD = 1000000007;
	static int[] FACT;
	static int[] INVFACT;

	static void precalc(int n) {
		FACT = new int[n];
		INVFACT = new int[n];
		INVFACT[0] = FACT[0] = 1;
		for (int i = 1; i < n; i++) {
			FACT[i] = (int) ((long) FACT[i - 1] * i % MOD);
			INVFACT[i] = modInverse(FACT[i]);
		}
	}

	static int modInverse(int a) {
		return valueOf(a).modInverse(valueOf(MOD)).intValue();
	}

	static void solve() throws Exception {
		long n = nextLong();
		int k = nextInt();
		out.println(solve(n, k));
	}

	static int solve(long n, int k) {
		Factor[] f = factorize(n);
		int divisors = 1;
		for (Factor e : f) {
			divisors *= e.pow + 1;
		}
		precalc(divisors + k);
		int ans = 0;
		for (int i = 0; i < 1 << f.length; i++) {
			int curD = divisors;
			for (int j = 0; j < f.length; j++) {
				if (((i >> j) & 1) == 1) {
					curD /= f[j].pow + 1;
					curD *= f[j].pow;
				}
			}
			int curF = function(curD, k);
			if (((Integer.bitCount(i)) & 1) == 0) {
				ans = ((ans + curF) % MOD);
			} else {
				ans = ((MOD + ans - curF) % MOD);
			}
		}
		return (ans);
	}

	static int function(int n, int k) {
		return (int) (((long) FACT[n + k - 1] * INVFACT[k] % MOD * INVFACT[n - 1]) % MOD);
	}

	static long[] getDivisors(long n) {
		List<Long> d = new ArrayList<Long>();
		for (long i = 1; i * i <= n; i++) {
			if (n % i != 0) {
				continue;
			}
			d.add(i);
			if (i * i != n) {
				d.add((n / i));
			}
		}
		long[] ret = new long[d.size()];
		for (int i = 0; i < d.size(); i++) {
			ret[i] = d.get(i);
		}
		sort(ret);
		return ret;
	}

	static Factor[] factorize(long n) {
		List<Factor> ret = new ArrayList<Factor>();
		for (long i = 2; i * i <= n; i++) {
			if (n % i != 0) {
				continue;
			}
			int count = 0;
			while (n % i == 0) {
				count++;
				n /= i;
			}
			ret.add(new Factor((int) i, count));
		}
		if (n > 1) {
			ret.add(new Factor(n, 1));
		}
		return ret.toArray(new Factor[ret.size()]);
	}

	static class Factor {
		long prime;
		int pow;

		public Factor(long prime, int pow) {
			this.prime = prime;
			this.pow = pow;
		}

	}

	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;

	static void debug(Object... a) {
		System.err.println(deepToString(a));
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	static double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) {
		try {
			File file = new File("lcm.in");
			InputStream input = System.in;
			OutputStream output = System.out;
			if (file.canRead()) {
				input = (new FileInputStream(file));
				output = (new PrintStream("lcm.out"));
			}
			br = new BufferedReader(new InputStreamReader(input));
			out = new PrintWriter(output);
			solve();
			out.close();
			br.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}